using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Transfuzija {
    internal class Program {
        static void Main(string[] args) {

            int N = int.Parse(Console.ReadLine());
            string[] zalihe = Console.ReadLine().Split(' ');
            List<string> pacijentGrupa = new List<string>();
            List<int> pacijentJedinice = new List<int>();
            List<int> pacijentO = new List<int>();
            List<int> pacijentA = new List<int>();
            List<int> pacijentB = new List<int>();
            List<int> pacijentAB = new List<int>();

            int O = int.Parse(zalihe[0]);
            int A = int.Parse(zalihe[1]);
            int B = int.Parse(zalihe[2]);
            int AB = int.Parse(zalihe[3]);

            for (int i = 0; i < N; i++) {

                string[] input = Console.ReadLine().Split(' ');

                pacijentGrupa.Add(input[0]);
                pacijentJedinice.Add(int.Parse(input[1]));

            }

            for (int i = 0; i < N; i++) {

                pacijentO.Add(0);
                pacijentA.Add(0);
                pacijentB.Add(0);
                pacijentAB.Add(0);
            }

            for (int i = 0; i < N; i++) {

                if (pacijentGrupa[i] == "O") {
                    
                    while (O > 0 && pacijentJedinice[i] > 0) {
                        pacijentO[i]++;
                        pacijentJedinice[i]--;
                        O--;
                    }
                    
                }

            }

            for (int i = 0; i < N; i++) {

                if (pacijentGrupa[i] == "A" || pacijentGrupa[i] == "B") {

                    while (O > 0 && pacijentJedinice[i] > 0) {
                        pacijentO[i]++;
                        pacijentJedinice[i]--;
                        O--;
                    }
                }
            }

            for (int i = 0; i < N; i++) {

                if (pacijentGrupa[i] == "A") {

                    while (A > 0 && pacijentJedinice[i] > 0) {
                        pacijentA[i]++;
                        pacijentJedinice[i]--;
                        A--;
                    }
                }
            }

            for (int i = 0; i < N; i++) {

                if (pacijentGrupa[i] == "B") {

                    while (B > 0 && pacijentJedinice[i] > 0) {
                        pacijentB[i]++;
                        pacijentJedinice[i]--;
                        B--;
                    }
                }
            }

            for (int i = 0; i < N; i++) {

                if (pacijentGrupa[i] == "AB") {

                    while (pacijentJedinice[i] > 0) {

                        if(O > 0) {
                            pacijentO[i]++;
                            pacijentJedinice[i]--;
                            O--;
                        }
                        else if (A > 0) {
                            pacijentA[i]++;
                            pacijentJedinice[i]--;
                            A--;
                        }
                        else if (B > 0) {
                            pacijentB[i]++;
                            pacijentJedinice[i]--;
                            B--;
                        }
                        else if (AB > 0) {
                            pacijentAB[i]++;
                            pacijentJedinice[i]--;
                            AB--;
                        }
                    }
                }
            }

            bool nemoguce = false;

            for (int i = 0; i < N; i++) {

                if (pacijentJedinice[i] > 0) {
                    nemoguce = true;
                    break;
                }

            }

            if (nemoguce) {
                Console.WriteLine("nemoguce");
            }
            else {
                Console.WriteLine("moguce");

                for (int i = 0; i < N; i++) {

                    Console.WriteLine("{0} {1} {2} {3}", pacijentO[i], pacijentA[i], pacijentB[i], pacijentAB[i]);

                }
            }

        }
    }
}